cordova.define("cordova-plugin-sdanalytics.sdanalytics", function(require, exports, module) {
var cordova = require('cordova');
var channel = require('cordova/channel');

channel.createSticky('onsdanalyticsInfoReady');
channel.waitForInitialization('onsdanalyticsInfoReady');


var sdanalytics = {

    udid:null,
    channelName:null,
    siteName:null,
    contentRealm:null,
    os:null,
    avaliableSubApp:null,
    accountRealm:null,
getInfo:function(callback){
    cordova.exec(callback,null,'sdanalytics','getInfo',[["LobbyAccountRealm","LobbyAvailableSubApp","LobbySkinID","LobbyPackageType","com.facebook.sdk.ApplicationId","FacebookAppID"]]);
},
onSubAppStart:function(subAppID){
    cordova.exec(null,null,'sdanalytics','onSubAppStart',[subAppID]);
},
onLogin: function (accountInfo) {
    cordova.exec(null,null, 'sdanalytics', 'onLogin', [accountInfo]);
},
onPay: function (orderID,currency,payMethod,itemName) {
    cordova.exec(null,null, 'sdanalytics', 'onPay', [orderID,currency,payMethod,itemName]);
},
onConsume: function (itemPrice,itemName) {
    cordova.exec(null,null, 'sdanalytics', 'onConsume', [itemPrice,itemName]);
},
onEvent:function(eventID,eventData){
    cordova.exec(null,null, 'sdanalytics', 'onEvent', [eventID,eventData]);
},
onPublicEvent:function(eventID,eventData){
    cordova.exec(null,null, 'sdanalytics', 'onPublicEvent', [eventID,eventData]);
    cordova.exec(null,null, 'talkingdata', 'onEvent', [eventID,eventData]);
},
uninstall:function(){
    cordova.exec(null,null, 'sdanalytics', 'uninstall', []);
},
cert:function(content,callback){
    cordova.exec(callback,null, 'sdanalytics', 'cert', [content]);
}
};

channel.onCordovaReady.subscribe(function() {
    sdanalytics.getInfo(function(info){
        sdanalytics.udid = info.udid;
        sdanalytics.channelName = info.channelName;
        sdanalytics.siteName = info.siteName;
        sdanalytics.contentRealm = info.contentRealm;
        sdanalytics.os = info.os;
        sdanalytics.avaliableSubApp = info.LobbyAvailableSubApp;
        sdanalytics.availableSubApp = info.LobbyAvailableSubApp;
        sdanalytics.accountRealm = info.LobbyAccountRealm;
        sdanalytics.packageType = info.LobbyPackageType;    // single,multiple,lobby
        sdanalytics.skinId = info.LobbySkinID;
        sdanalytics.displayWidth = info.displayWidth;
        sdanalytics.displayHeight = info.displayHeight;
        if(info.FacebookAppID){
            sdanalytics.facebookAppID = info.FacebookAppID;
        }else if(info["com.facebook.sdk.ApplicationId"]){
            sdanalytics.facebookAppID = info["com.facebook.sdk.ApplicationId"];
        }
        if(info.MCC){
            sdanalytics.MCC = info.MCC;
            sdanalytics.MNC = info.MNC;
        }
        if(info.countryCode){
            sdanalytics.countryCode = info.countryCode;
            sdanalytics.languageTag = info.languageTag;
            sdanalytics.currencyCode = info.currencyCode;
            sdanalytics.currencySymbol = info.currencySymbol;
        }
        if(info.storefrontCountryCode){
            sdanalytics.storefrontCountryCode = info.storefrontCountryCode;
        }
        sdanalytics.CarrierCountryCode = info.CarrierCountryCode;
        sdanalytics.SimCountryCode = info.SimCountryCode;

        sdanalytics.metadata = info.metadata;
        sdanalytics.preference = info.preference;


        if('android'==info.os){ // 仅在android上提供isPackageInstalled功能
            sdanalytics.isPackageInstalled=function(packageID,callback){
                cordova.exec(callback,null,'sdanalytics','isPackageInstalled',[packageID]);
            }
        }

        channel.onsdanalyticsInfoReady.fire();
    })
})

    
module.exports = sdanalytics;

});
